=== debian/changelog ===
memtest86+ (6.10-4~bpo22.04.1) jammy-backports; urgency=medium

  * Rebuild for jammy-backports. (LP: #1998834)

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Fri, 24 Mar 2023 13:41:19 +0100

memtest86+ (6.10-4) unstable; urgency=medium

  * Update README.Debian with renamed 32bit files.

 -- Felix Zielcke <fzielcke@z-51.de>  Sat, 11 Feb 2023 11:16:22 +0100

memtest86+ (6.10-3) unstable; urgency=medium

  * Rename 32bit files (x32 -> ia32) to match EFI Specification. Thanks
    to Jonas Stalder for the hint.

 -- Felix Zielcke <fzielcke@z-51.de>  Sat, 11 Feb 2023 10:43:09 +0100

memtest86+ (6.10-2) unstable; urgency=medium

  * d/patches/fix_64bit_build.patch: Add patch to fix FTBFS on i386.
  * Bump Standards-Version to 4.6.2.

 -- Felix Zielcke <fzielcke@z-51.de>  Sat, 04 Feb 2023 07:16:14 +0100

memtest86+ (6.10-1) unstable; urgency=medium

  * New upstream release.
  * Also suggest grub-efi. (Closes: #1029133)

 -- Felix Zielcke <fzielcke@z-51.de>  Fri, 03 Feb 2023 18:20:01 +0100

memtest86+ (6.01-1) unstable; urgency=medium

  [ Felix Zielcke ]
  * Fix file names of EFI images in d/README.Debian. Thanks Michael
    Prokop for the hint. (Closes: #1023638)

  [ Fabio Fantoni ]
  * New upstream version 6.01

 -- Felix Zielcke <fzielcke@z-51.de>  Fri, 13 Jan 2023 14:26:12 +0100

memtest86+ (6.00-1) unstable; urgency=medium

  [ Fabio Fantoni ]
  * New upstream version
  * d/control: remove memtest86 from suggests
  * refresh d/patches

  [ Felix Zielcke ]
  * Upload to unstable.

 -- Felix Zielcke <fzielcke@z-51.de>  Mon, 24 Oct 2022 20:01:48 +0200

memtest86+ (6.00~beta3-1) experimental; urgency=medium

  [ Felix Zielcke ]
  * Disable hurd for now.

  [ Fabio Fantoni ]
  * New upstream beta version

 -- Felix Zielcke <fzielcke@z-51.de>  Wed, 20 Jul 2022 16:25:41 +0200

memtest86+ (6.00~beta2-1) experimental; urgency=medium

  [ Fabio Fantoni ]
  * New upstream beta version.
  * Update console parameter in d/grub and README.Debian.
  * Bumped Standards-Version to 4.6.1, no needed changes.

 -- Felix Zielcke <fzielcke@z-51.de>  Fri, 03 Jun 2022 12:15:59 +0200

memtest86+ (6.00~beta1-1) experimental; urgency=medium

  * New upstream beta version.
  * d/watch: use new git and use uversionmangle for support
    pre-release versions.
  * Try to add hurd and kfreebsd support with new version building only
    32 or 64 bit instead of both like on linux with gcc-multilib

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Thu, 05 May 2022 19:35:33 +0200

memtest86+ (6.0~20220422-1) experimental; urgency=medium

  [ Fabio Fantoni ]
  * New upstream snapshot from new official git. (Closes: #943752)
    Git commit: 2a7631daab811fc8ca12c2eb5f0dcc974fe2fc8b
  * d/postrm: don't run update-grub if in a container
  * d/control: add Felix Zielcke to uploaders
  * add upstream metadata

  [ Felix Zielcke ]
  * Various packaging changes based on my works on pcmemtest.
  * Update d/copyright.
  * Remove completely lilo support.
  * Booting ISO Image from USB should now work. (Closes: #1004126)
  * Remove all old patches.
  * d/patches/reproducible-builds.patch: New patch to make builds fully
    reproducible.

 -- Felix Zielcke <fzielcke@z-51.de>  Fri, 22 Apr 2022 20:22:38 +0200
