=== debian/control ===
Source: memtest86+
Section: misc
Priority: optional
Maintainer: Fabio Fantoni <fantonifabio@tiscali.it>
Uploaders: Felix Zielcke <fzielcke@z-51.de>
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dosfstools,
 gcc-multilib [!hurd-any !kfreebsd-any],
 mtools,
 xorriso,
Homepage: https://www.memtest.org/
Vcs-Git: https://salsa.debian.org/debian/memtest86plus.git -b ubuntu/jammy-backports
Vcs-Browser: https://salsa.debian.org/debian/memtest86plus
Standards-Version: 4.6.2

Package: memtest86+
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386
Depends: ${misc:Depends}
Suggests:
 grub-efi | grub-pc | grub-legacy,
 memtester,
 mtools,
Description: thorough real-mode memory tester
 Memtest86+ scans your RAM for errors.
 .
 This tester runs independently of any OS - it is run at computer
 boot-up, so that it can test *all* of your memory.  You may want to
 look at `memtester', which allows to test your memory within Linux,
 but this one won't be able to test your whole RAM.
 .
 It can output a list of bad RAM regions usable by the BadRAM kernel
 patch, so that you can still use your old RAM with one or two bad bits.
 .
 Memtest86+ is based on memtest86 3.0, and adds support for recent
 hardware, as well as a number of general-purpose improvements,
 including many patches to memtest86 available from various sources.
 .
 Both memtest86 and memtest86+ are being worked on in parallel.
