## memtest86+ 6.20

=== debian/changelog ===
memtest86+ (6.20-3) unstable; urgency=medium

  [ Felix Zielcke ]
  * Add --class memtest and --id memtest86+(-serial) to grub
    menuentries.
  * Switch to always use linux cmd in grub menuentries.

  [ Fabio Fantoni ]
  * d/control: add grub-common to depends (LP: #2031420)
    Thanks to Julian Andres Klode for the hint.

 -- Felix Zielcke <fzielcke@z-51.de>  Sat, 19 Aug 2023 12:40:45 +0200

memtest86+ (6.20-2) unstable; urgency=medium

  * Upload to unstable.

 -- Felix Zielcke <fzielcke@z-51.de>  Sun, 11 Jun 2023 09:38:25 +0200

memtest86+ (6.20-1) experimental; urgency=medium

  * New upstream release.
  * Remove d/patches/fix_64bit_build.patch. (Included upstream.)
  * Add to d/control Rules-Requires-Root: no.
  * Fix spelling error in description. Thanks lintian.

 -- Felix Zielcke <fzielcke@z-51.de>  Sun, 07 May 2023 19:34:49 +0200
