=== debian/control ===
--- 
+++ 
@@ -11,13 +11,14 @@
  mtools,
  xorriso,
 Homepage: https://www.memtest.org/
-Vcs-Git: https://salsa.debian.org/debian/memtest86plus.git -b ubuntu/jammy-backports
+Vcs-Git: https://salsa.debian.org/debian/memtest86plus.git
 Vcs-Browser: https://salsa.debian.org/debian/memtest86plus
 Standards-Version: 4.6.2
+Rules-Requires-Root: no
 
 Package: memtest86+
 Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386
-Depends: ${misc:Depends}
+Depends: grub-common, ${misc:Depends}
 Suggests:
  grub-efi | grub-pc | grub-legacy,
  memtester,
@@ -27,7 +28,7 @@
  .
  This tester runs independently of any OS - it is run at computer
  boot-up, so that it can test *all* of your memory.  You may want to
- look at `memtester', which allows to test your memory within Linux,
+ look at `memtester', which allows one to test your memory within Linux,
  but this one won't be able to test your whole RAM.
  .
  It can output a list of bad RAM regions usable by the BadRAM kernel
