=== debian/changelog ===
memtest86+ (7.00-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Felix Zielcke <fzielcke@z-51.de>  Fri, 19 Jan 2024 18:23:30 +0100

memtest86+ (7.00-1) unstable; urgency=medium

  * New upstream version.
  * Upload to unstable.

 -- Felix Zielcke <fzielcke@z-51.de>  Sun, 07 Jan 2024 17:11:47 +0100

memtest86+ (7.00~git04012023.5dde13b-1) experimental; urgency=medium

  [ Felix Zielcke ]
  * Don't suggest grub-legacy anymore. The plans are to completely
    remove it from Debian.
  * New upstream pre release snapshot of 7.00
  * d/patches/reproducible-builds.patch: Rebase.

  [ Fabio Fantoni ]
  * d/control: update and improve package description

 -- Felix Zielcke <fzielcke@z-51.de>  Mon, 04 Dec 2023 09:51:07 +0100
