=== debian/control ===
--- 
+++ 
@@ -20,11 +20,14 @@
 Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386
 Depends: grub-common, ${misc:Depends}
 Suggests:
- grub-efi | grub-pc | grub-legacy,
+ grub-efi | grub-pc,
  memtester,
  mtools,
-Description: thorough real-mode memory tester
- Memtest86+ scans your RAM for errors.
+Description: stand-alone memory tester for x86 and x86-64
+ Memtest86+ provides a more thorough memory check than
+ that provided by BIOS memory tests. Can be loaded and run either
+ directly by a PC BIOS (legacy or UEFI) or via an intermediate
+ bootloader.
  .
  This tester runs independently of any OS - it is run at computer
  boot-up, so that it can test *all* of your memory.  You may want to
@@ -33,9 +36,3 @@
  .
  It can output a list of bad RAM regions usable by the BadRAM kernel
  patch, so that you can still use your old RAM with one or two bad bits.
- .
- Memtest86+ is based on memtest86 3.0, and adds support for recent
- hardware, as well as a number of general-purpose improvements,
- including many patches to memtest86 available from various sources.
- .
- Both memtest86 and memtest86+ are being worked on in parallel.
