## memtest86+ 7.20

=== build32/Makefile ===
--- 
+++ 
@@ -10,8 +10,9 @@
   GIT_AVAILABLE = true
 endif
 
-CFLAGS = -std=c11 -Wall -Wextra -Wshadow -m32 -march=i586 -fpic -fno-builtin \
-         -ffreestanding -fomit-frame-pointer -fno-stack-protector
+CFLAGS = -std=gnu11 -Wall -Wextra -Wshadow -m32 -march=i586 -fpic -fno-builtin \
+         -ffreestanding -fomit-frame-pointer -fno-stack-protector \
+         -fexcess-precision=standard -DARCH_BITS=32
 
 ifeq ($(DEBUG), 1)
   CFLAGS+=-ggdb3 -DDEBUG_GDB
@@ -44,7 +45,8 @@
            system/screen.o \
            system/serial.o \
            system/smbios.o \
-           system/smbus.o \
+           system/i2c_x86.o \
+           system/spd.o \
            system/smp.o \
            system/temperature.o \
            system/timers.o \
@@ -228,7 +230,7 @@
 
 GRUB_MKIMAGE := $(shell command -v grub2-mkimage || command -v grub-mkimage)
 
-GRUB_MODULES = iso9660 fat part_msdos all_video font gfxterm gfxmenu \
+GRUB_MODULES = iso9660 fat part_msdos part_gpt all_video font gfxterm gfxmenu \
                boot chain configfile echo ls
 
 grub-eltorito.img:
