=== debian/changelog ===
memtest86+ (7.20-1) unstable; urgency=medium

  * New upstream version 7.20 (Closes: #1087353)
  * Update d/copyright

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Sun, 17 Nov 2024 17:43:10 +0100

memtest86+ (7.00-2) unstable; urgency=medium

  [ Felix Zielcke ]
  * Rewrite generation of grub menu entries.
    Patch by Pascal Hambourg. (MR!3)
  * Fix some minor bugs in postrm and postinst. And make them more
    efficiently. Patch by Pascal Hambourg (MR!4)
  * Add systemd-boot support. Thanks to Russell Coker. (Closes: #1081704)

  [ Fabio Fantoni ]
  * Update standards version to 4.7.0, no changes needed

 -- Felix Zielcke <fzielcke@z-51.de>  Sun, 15 Sep 2024 13:13:49 +0200
