=== debian/control ===
--- 
+++ 
@@ -13,16 +13,13 @@
 Homepage: https://www.memtest.org/
 Vcs-Git: https://salsa.debian.org/debian/memtest86plus.git
 Vcs-Browser: https://salsa.debian.org/debian/memtest86plus
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 
 Package: memtest86+
 Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386
 Depends: grub-common, ${misc:Depends}
-Suggests:
- grub-efi | grub-pc,
- memtester,
- mtools,
+Suggests: grub-efi | grub-pc, memtester, mtools
 Description: stand-alone memory tester for x86 and x86-64
  Memtest86+ provides a more thorough memory check than
  that provided by BIOS memory tests. Can be loaded and run either
