=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_clean:
ifneq (${DEB_HOST_ARCH},kfreebsd-amd64)
	dh_auto_clean --sourcedirectory=build32
endif
ifeq (,$(filter hurd-i386 kfreebsd-i386, $(DEB_HOST_ARCH)))
	dh_auto_clean --sourcedirectory=build64
endif

override_dh_fixperms:
	dh_fixperms
	chmod -x debian/memtest86+/usr/lib/memtest86+/*
	chmod -x debian/memtest86+/boot/memtest86+*

override_dh_auto_build:
ifneq (${DEB_HOST_ARCH},kfreebsd-amd64)
	dh_auto_build --sourcedirectory=build32 -- all iso
endif
ifeq (,$(filter hurd-i386 kfreebsd-i386, $(DEB_HOST_ARCH)))
	dh_auto_build --sourcedirectory=build64 -- all iso
endif

override_dh_installdocs:
	dh_installdocs README.md

override_dh_installexamples:
	dh_installexamples debian/grub-menu.lst
