=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
  https://github.com/memtest86plus/memtest86plus/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
